        org 32768

STANDARD equ 0
BOLD     equ 0
HALFBOLD equ 1

main_loop:
        halt
        call one_scroll
        ld bc,$7ffe
        in a,(c)
        and 1
        jr nz, main_loop
        ret

one_scroll:
        ld a,(bpos)
        or a
        jr z,move_text
        dec a
        ld (bpos),a
        jr do_scroll
move_text:
        ld a,7
        ld (bpos),a
text_adr: equ $+1
        ld hl,text
        ld a,(hl)
        inc hl
        ld (text_adr),hl
        cp 13
        jr nz,get_char
        ld hl,text
        ld a,(hl)
        inc hl
        ld (text_adr),hl
get_char:
        ld h,0
        ld l,a
        add hl,hl
        add hl,hl
        add hl,hl
        ld de,15360
        add hl,de
        ld de,buf
if STANDARD
        rept 8
          ldi
        endm
endif

if BOLD
        rept 8
          ld a,(hl)
          sla a
          or (hl)
          ld (de),a
          inc l
          inc de
        endm
endif

if HALFBOLD
        rept 4
          ldi
        endm
        rept 4
          ld a,(hl)
          sla a
          or (hl)
          ld (de),a
          inc l
          inc de
        endm
endif

do_scroll:
        ld hl,20704+31
        ld de,buf
        ld b,8
loop1:
        push hl
        ld c,32
        ld a,(de)
        rla
        ld (de),a
loop2:
        ld a,(hl)
        rla
        ld (hl),a
        dec l
        dec c
        jr nz,loop2
        inc de
        pop hl
        inc h
        djnz loop1

        ret

buf:    ds 8
bpos:   db 0
text:   defm "Tekst scrollera... wpisany jako parametr dla defm albo "
        defm "w dowolne miejsce w pamieci a wtedy zamiast text: defm "
        defm "nalezy uzyc text: equ adres_tekstu "
        db 13
        end 32768
